Summary:       Library to control and monitor control groups
Name:          libcgroup
Version:       3.1.0
Release:       3%{?dist}
License:       LGPLv2+
URL:           http://libcg.sourceforge.net/
Source0:       https://github.com/%{name}/%{name}/releases/download/v%{version}/%{name}-%{version}.tar.gz
Source1:       cgconfig.service
Patch5000:     disable-creation-of-the-default-group-on-startup.patch
BuildRequires: autoconf, automake, libtool, gcc, gcc-c++, make, systemd-devel
BuildRequires: byacc, coreutils, flex, pam-devel, systemd-units
Requires(pre): shadow-utils
%{?systemd_requires}

%description
Libcgroup is a library that abstracts the control group file system in Linux.

%package       tools
Summary:       Command-line utility programs, services and daemons for libcgroup
Requires:      %{name} = %{version}-%{release}
Requires:      systemd >= 217-0.2

%description   tools
This package provides command-line programs, services and a daemon for
manipulating control groups using the libcgroup library.

%package       pam
Summary:       A Pluggable Authentication Module for libcgroup
Requires:      %{name} = %{version}-%{release}

%description   pam
This package provides the ability of Linux-PAM module which allows administrators
to classify the user's login processes to pre-configured control group.

%package       devel
Summary:       Development libraries to develop applications that utilize control groups
Requires:      %{name} = %{version}-%{release}

%description   devel
This package provides API to create, delete and modify cgroup nodes.

%prep
%autosetup -p1

%build
autoreconf -vif
%configure --enable-pam-module-dir=%{_libdir}/security \
           --enable-opaque-hierarchy="name=systemd" \
           --disable-daemon
%make_build

%install
%make_install

install -d %{buildroot}%{_sysconfdir}
install -m644 samples/config/cgconfig.conf %{buildroot}/%{_sysconfdir}/cgconfig.conf
install -m644 samples/config/cgsnapshot_denylist.conf %{buildroot}/%{_sysconfdir}/cgsnapshot_denylist.conf

rm -f %{buildroot}%{_libdir}/security/pam_cgroup.{,l}a
rm -f %{buildroot}%{_libdir}/security/pam_cgroup.so.*
rm -f %{buildroot}%{_libdir}/*.{,l}a
rm -f %{buildroot}%{_libdir}/libcgroupfortesting.*
rm -f %{buildroot}%{_mandir}/man5/cgred.conf.5*
rm -f %{buildroot}%{_mandir}/man5/cgrules.conf.5*
rm -f %{buildroot}%{_mandir}/man8/cgrulesengd.8*

install -d %{buildroot}%{_unitdir}
install -m644 %{SOURCE1} %{buildroot}%{_unitdir}/
install -d %{buildroot}%{_sysconfdir}/sysconfig

%post tools
%systemd_post cgconfig.service

%preun tools
%systemd_preun cgconfig.service

%postun tools
%systemd_postun_with_restart cgconfig.service

%files
%license COPYING
%doc README
%{_libdir}/libcgroup.so.*

%files tools
%doc README README_systemd
%{_bindir}/cgcreate
%{_bindir}/cgget
%{_bindir}/cgset
%{_bindir}/cgdelete
%{_bindir}/lscgroup
%{_bindir}/lssubsys
%{_bindir}/cgsnapshot
%{_bindir}/cgclassify
%{_bindir}/cgxget
%{_bindir}/cgxset
%{_bindir}/libcgroup_systemd_idle_thread
%attr(0755, root, root) %{_bindir}/cgexec
%{_sbindir}/cgconfigparser
%config(noreplace) %{_sysconfdir}/cgconfig.conf
%config(noreplace) %{_sysconfdir}/cgsnapshot_denylist.conf
%{_unitdir}/cgconfig.service
%attr(0644, root, root) %{_mandir}/man1/*
%attr(0644, root, root) %{_mandir}/man5/*
%attr(0644, root, root) %{_mandir}/man8/*

%files pam
%attr(0755,root,root) %{_libdir}/security/pam_cgroup.so

%files devel
%{_includedir}/libcgroup.h
%{_includedir}/libcgroup/*.h
%{_libdir}/libcgroup.so
%{_libdir}/pkgconfig/libcgroup.pc

%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.1.0-3
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.1.0-2
- Rebuilt for loongarch release

* Mon Feb 05 2024 Upgrade Robot <upbot@opencloudos.org> - 3.1.0-1
- Upgrade to version 3.1.0 for fully cgroup v2 support.

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.0.2-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.0.2-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.0.2-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Jul 12 2022 cunshunxia <cunshunxia@tencent.com> - 2.0.2-1
- initial build
